Loading...
Searching...
No Matches
LeafData< ValueIndex, CoordT, MaskT, LOG2DIM > Struct Template Reference

`#include <nanovdb/NanoVDB.h>`

Inheritance diagram for LeafData< ValueIndex, CoordT, MaskT, LOG2DIM >:

## Public Types

using | BaseT = LeafIndexBase<CoordT, MaskT, LOG2DIM>
using | BuildType = ValueIndex
using | ValueType
using | FloatType
using | ArrayType

## Public Member Functions

uint64_t | lastOffset () const
uint64_t | getMin () const
uint64_t | getMax () const
uint64_t | getAvg () const
uint64_t | getDev () const
uint64_t | getValue (uint32_t i) const
| LeafData ()=delete
| This class cannot be constructed or deleted.
| LeafData (const LeafData &)=delete
LeafData & | operator= (const LeafData &)=delete
| ~LeafData ()=delete
void | setValueOnly (uint32_t offset, const ValueType &value)
void | setValue (uint32_t offset, const ValueType &value)
void | setOn (uint32_t offset)
void | setMin (const ValueType &v)
void | setMax (const ValueType &v)
void | setAvg (const FloatType &v)
void | setDev (const FloatType &v)
void | setOrigin (const T &ijk)
void | fill (const ValueType &v)
bool | hasStats () const
const uint64_t & | firstOffset () const
void | setMin (const ValueType &)
void | setMax (const ValueType &)
void | setAvg (const FloatType &)
void | setDev (const FloatType &)

## Static Public Member Functions

static uint32_t | valueCount ()
static constexpr uint32_t | padding ()
| Return padding of this class in bytes, due to aliasing and 32B alignment.
static uint64_t | memUsage ()
static bool | hasStats ()

## Public Attributes

CoordT | mBBoxMin
uint8_t | mBBoxDif [3]
uint8_t | mFlags
MaskT< LOG2DIM > | mValueMask
ValueType | mMinimum
ValueType | mMaximum
FloatType | mAverage
FloatType | mStdDevi
ValueType | mValues [1u<< 3 *LOG2DIM]
uint64_t | mOffset
uint64_t | mPrefixSum

## Static Public Attributes

static constexpr bool | FIXED_SIZE

## Member Typedef Documentation

## ArrayType

using ArrayType

## BaseT

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BaseT = LeafIndexBase<CoordT, MaskT, LOG2DIM>

## BuildType

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BuildType = ValueIndex

## FloatType

using FloatType

## ValueType

using ValueType

## Constructor & Destructor Documentation

## LeafData() [1/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( |  | ) |

delete

This class cannot be constructed or deleted.

## LeafData() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( | const LeafData< ValueIndex, CoordT, MaskT, LOG2DIM > & |  | ) |

delete

## ~LeafData()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

~LeafData | ( |  | ) |

delete

## Member Function Documentation

## fill()

void fill | ( | const ValueType & | v | ) |

inline

## firstOffset()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

const uint64_t & firstOffset | ( |  | ) | const

inlineinherited

## getAvg()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t getAvg | ( |  | ) | const

inline

## getDev()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t getDev | ( |  | ) | const

inline

## getMax()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t getMax | ( |  | ) | const

inline

## getMin()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t getMin | ( |  | ) | const

inline

## getValue()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t getValue | ( | uint32_t | i | ) | const

inline

## hasStats() [1/2]

bool hasStats | ( |  | ) |

inlinestatic

## hasStats() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

bool hasStats | ( |  | ) | const

inlineinherited

## lastOffset()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t lastOffset | ( |  | ) | const

inline

## memUsage()

uint64_t memUsage | ( |  | ) |

inlinestatic

## operator=()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData & operator= | ( | const LeafData< ValueIndex, CoordT, MaskT, LOG2DIM > & |  | ) |

delete

## padding()

constexpr uint32_t padding | ( |  | ) |

inlinestaticconstexpr

Return padding of this class in bytes, due to aliasing and 32B alignment.

Note
  The extra bytes are not necessarily at the end, but can come from aliasing of individual data members.

## setAvg() [1/2]

void setAvg | ( | const FloatType & | v | ) |

inline

## setAvg() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setAvg | ( | const FloatType & |  | ) |

inlineinherited

## setDev() [1/2]

void setDev | ( | const FloatType & | v | ) |

inline

## setDev() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setDev | ( | const FloatType & |  | ) |

inlineinherited

## setMax() [1/2]

void setMax | ( | const ValueType & | v | ) |

inline

## setMax() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMax | ( | const ValueType & |  | ) |

inlineinherited

## setMin() [1/2]

void setMin | ( | const ValueType & | v | ) |

inline

## setMin() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMin | ( | const ValueType & |  | ) |

inlineinherited

## setOn()

void setOn | ( | uint32_t | offset | ) |

inline

## setOrigin()

void setOrigin | ( | const T & | ijk | ) |

inline

## setValue()

void setValue | ( | uint32_t | offset,
|  | const ValueType & | value )

inline

## setValueOnly()

void setValueOnly | ( | uint32_t | offset,
|  | const ValueType & | value )

inline

## valueCount()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint32_t valueCount | ( |  | ) |

inlinestatic

## Member Data Documentation

## FIXED_SIZE

bool FIXED_SIZE

staticconstexpr

## mAverage

FloatType mAverage

## mBBoxDif

uint8_t mBBoxDif[3]

## mBBoxMin

CoordT mBBoxMin

## mFlags

uint8_t mFlags

## mMaximum

ValueType mMaximum

## mMinimum

ValueType mMinimum

## mOffset

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t mOffset

inherited

## mPrefixSum

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t mPrefixSum

inherited

## mStdDevi

FloatType mStdDevi

## mValueMask

MaskT<LOG2DIM> mValueMask

## mValues

ValueType mValues[1u<< 3 *LOG2DIM]